
_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;C_Meter_AVR.c,29 :: 		void main()
;C_Meter_AVR.c,32 :: 		bool calibration_flag = true;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
;C_Meter_AVR.c,35 :: 		system_setup();
	CALL       _system_setup+0
;C_Meter_AVR.c,36 :: 		setup_interrupt();
	CALL       _setup_interrupt+0
;C_Meter_AVR.c,37 :: 		InitTimer1();
	CALL       _InitTimer1+0
;C_Meter_AVR.c,39 :: 		t_cal = 1.0 / 22587.0;
	LDI        R27, 12
	STS        _t_cal+0, R27
	LDI        R27, 178
	STS        _t_cal+1, R27
	LDI        R27, 57
	STS        _t_cal+2, R27
	LDI        R27, 56
	STS        _t_cal+3, R27
;C_Meter_AVR.c,40 :: 		c_cal = t_cal / 77616.0;
	LDI        R20, 0
	LDI        R21, 152
	LDI        R22, 151
	LDI        R23, 71
	LDS        R16, _t_cal+0
	LDS        R17, _t_cal+1
	LDS        R18, _t_cal+2
	LDS        R19, _t_cal+3
	CALL       _float_fpdiv1+0
	STS        _c_cal+0, R16
	STS        _c_cal+1, R17
	STS        _c_cal+2, R18
	STS        _c_cal+3, R19
;C_Meter_AVR.c,42 :: 		int_count = 0;
	LDI        R27, 0
	STS        _int_count+0, R27
	STS        _int_count+1, R27
	STS        _int_count+2, R27
	STS        _int_count+3, R27
;C_Meter_AVR.c,44 :: 		while(1)
L_main0:
;C_Meter_AVR.c,47 :: 		if( sec_flag )
	LDS        R16, _sec_flag+0
	TST        R16
	BRNE       L__main6
	JMP        L_main2
L__main6:
;C_Meter_AVR.c,50 :: 		sprintf( uart_text, "Interrupts : %u\r\n", timer_count_end );
	LDS        R16, _timer_count_end+0
	LDS        R17, _timer_count_end+1
	LDS        R18, _timer_count_end+2
	LDS        R19, _timer_count_end+3
	PUSH       R19
	PUSH       R18
	PUSH       R17
	PUSH       R16
	LDI        R27, hi_addr(?lstr_1_C_Meter_AVR+0)
	PUSH       R27
	LDI        R27, #lo_addr(?lstr_1_C_Meter_AVR+0)
	PUSH       R27
	LDI        R27, hi_addr(_uart_text+0)
	PUSH       R27
	LDI        R27, #lo_addr(_uart_text+0)
	PUSH       R27
	CALL       _sprintf+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 8
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;C_Meter_AVR.c,51 :: 		UART1_Write_Text( uart_text );
	LDI        R27, #lo_addr(_uart_text+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_uart_text+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,53 :: 		t_meas = 1.0 / timer_count_end;
	LDS        R16, _timer_count_end+0
	LDS        R17, _timer_count_end+1
	LDS        R18, _timer_count_end+2
	LDS        R19, _timer_count_end+3
	CALL       _float_ulong2fp+0
	MOVW       R20, R16
	MOVW       R22, R18
	LDI        R16, 0
	LDI        R17, 0
	LDI        R18, 128
	LDI        R19, 63
	CALL       _float_fpdiv1+0
	STS        _t_meas+0, R16
	STS        _t_meas+1, R17
	STS        _t_meas+2, R18
	STS        _t_meas+3, R19
;C_Meter_AVR.c,54 :: 		c_meas = t_meas / 77616.0;
	LDI        R20, 0
	LDI        R21, 152
	LDI        R22, 151
	LDI        R23, 71
	LDS        R16, _t_meas+0
	LDS        R17, _t_meas+1
	LDS        R18, _t_meas+2
	LDS        R19, _t_meas+3
	CALL       _float_fpdiv1+0
	STS        _c_meas+0, R16
	STS        _c_meas+1, R17
	STS        _c_meas+2, R18
	STS        _c_meas+3, R19
;C_Meter_AVR.c,55 :: 		final = fabs( c_cal - c_meas );
	LDS        R20, _c_meas+0
	LDS        R21, _c_meas+1
	LDS        R22, _c_meas+2
	LDS        R23, _c_meas+3
	LDS        R16, _c_cal+0
	LDS        R17, _c_cal+1
	LDS        R18, _c_cal+2
	LDS        R19, _c_cal+3
	CALL       _float_fpsub1+0
	MOVW       R2, R16
	MOVW       R4, R18
	CALL       _fabs+0
	STS        _final+0, R16
	STS        _final+1, R17
	STS        _final+2, R18
	STS        _final+3, R19
;C_Meter_AVR.c,57 :: 		UART1_Write_Text( "Calibrated: " );
	LDI        R27, #lo_addr(?lstr2_C_Meter_AVR+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr2_C_Meter_AVR+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,58 :: 		FloatToStr( c_cal, uart_text );
	LDI        R27, #lo_addr(_uart_text+0)
	MOV        R6, R27
	LDI        R27, hi_addr(_uart_text+0)
	MOV        R7, R27
	LDS        R2, _c_cal+0
	LDS        R3, _c_cal+1
	LDS        R4, _c_cal+2
	LDS        R5, _c_cal+3
	CALL       _FloatToStr+0
;C_Meter_AVR.c,59 :: 		UART1_Write_Text( uart_text );
	LDI        R27, #lo_addr(_uart_text+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_uart_text+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,60 :: 		UART1_Write_Text( "\r\n" );
	LDI        R27, #lo_addr(?lstr3_C_Meter_AVR+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr3_C_Meter_AVR+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,61 :: 		UART1_Write_Text( "Final: " );
	LDI        R27, #lo_addr(?lstr4_C_Meter_AVR+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr4_C_Meter_AVR+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,62 :: 		FloatToStr( final, final_text );
	LDI        R27, #lo_addr(_final_text+0)
	MOV        R6, R27
	LDI        R27, hi_addr(_final_text+0)
	MOV        R7, R27
	LDS        R2, _final+0
	LDS        R3, _final+1
	LDS        R4, _final+2
	LDS        R5, _final+3
	CALL       _FloatToStr+0
;C_Meter_AVR.c,63 :: 		UART1_Write_Text( final_text );
	LDI        R27, #lo_addr(_final_text+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_final_text+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,64 :: 		UART1_Write_Text( "\r\n" );
	LDI        R27, #lo_addr(?lstr5_C_Meter_AVR+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr5_C_Meter_AVR+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,66 :: 		sec_flag = false;
	LDI        R27, 0
	STS        _sec_flag+0, R27
;C_Meter_AVR.c,67 :: 		int_count = 0;
	LDI        R27, 0
	STS        _int_count+0, R27
	STS        _int_count+1, R27
	STS        _int_count+2, R27
	STS        _int_count+3, R27
;C_Meter_AVR.c,68 :: 		timer_count_end = 0;
	LDI        R27, 0
	STS        _timer_count_end+0, R27
	STS        _timer_count_end+1, R27
	STS        _timer_count_end+2, R27
	STS        _timer_count_end+3, R27
;C_Meter_AVR.c,69 :: 		}
L_main2:
;C_Meter_AVR.c,70 :: 		}
	JMP        L_main0
;C_Meter_AVR.c,71 :: 		}
L_end_main:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main

_system_setup:

;C_Meter_AVR.c,73 :: 		void system_setup( void )
;C_Meter_AVR.c,76 :: 		C_METER_INT_DIR = 0;
	PUSH       R2
	PUSH       R3
	IN         R27, DDD2_bit+0
	CBR        R27, BitMask(DDD2_bit+0)
	OUT        DDD2_bit+0, R27
;C_Meter_AVR.c,77 :: 		C_METER_RST_DIR = 1;
	IN         R27, DDA6_bit+0
	SBR        R27, BitMask(DDA6_bit+0)
	OUT        DDA6_bit+0, R27
;C_Meter_AVR.c,80 :: 		C_METER_RST = 0;
	IN         R27, PORTA6_bit+0
	CBR        R27, BitMask(PORTA6_bit+0)
	OUT        PORTA6_bit+0, R27
;C_Meter_AVR.c,81 :: 		Delay_ms(50);
	LDI        R18, 3
	LDI        R17, 8
	LDI        R16, 120
L_system_setup3:
	DEC        R16
	BRNE       L_system_setup3
	DEC        R17
	BRNE       L_system_setup3
	DEC        R18
	BRNE       L_system_setup3
;C_Meter_AVR.c,82 :: 		C_METER_RST = 1;
	IN         R27, PORTA6_bit+0
	SBR        R27, BitMask(PORTA6_bit+0)
	OUT        PORTA6_bit+0, R27
;C_Meter_AVR.c,85 :: 		UART1_Init( 9600 );
	LDI        R27, 51
	OUT        UBRRL+0, R27
	LDI        R27, 0
	OUT        UBRRH+0, R27
	CALL       _UART1_Init+0
;C_Meter_AVR.c,86 :: 		UART1_Write_Text( "UART Initialized\r\n" );
	LDI        R27, #lo_addr(?lstr6_C_Meter_AVR+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr6_C_Meter_AVR+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;C_Meter_AVR.c,88 :: 		}
L_end_system_setup:
	POP        R3
	POP        R2
	RET
; end of _system_setup

_setup_interrupt:

;C_Meter_AVR.c,90 :: 		void setup_interrupt( void )
;C_Meter_AVR.c,92 :: 		GICR |= ( 1 << 6 );
	IN         R27, GICR+0
	SBR        R27, 64
	OUT        GICR+0, R27
;C_Meter_AVR.c,93 :: 		MCUCR |= 3;
	IN         R16, MCUCR+0
	ORI        R16, 3
	OUT        MCUCR+0, R16
;C_Meter_AVR.c,94 :: 		SREG |= ( 1 << 7 );
	IN         R16, SREG+0
	ORI        R16, 128
	OUT        SREG+0, R16
;C_Meter_AVR.c,95 :: 		}
L_end_setup_interrupt:
	RET
; end of _setup_interrupt

_interrupt:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;C_Meter_AVR.c,97 :: 		void interrupt() iv IVT_ADDR_INT0 ics ICS_AUTO
;C_Meter_AVR.c,99 :: 		int_count++;
	LDS        R16, _int_count+0
	LDS        R17, _int_count+1
	LDS        R18, _int_count+2
	LDS        R19, _int_count+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _int_count+0, R16
	STS        _int_count+1, R17
	STS        _int_count+2, R18
	STS        _int_count+3, R19
;C_Meter_AVR.c,100 :: 		}
L_end_interrupt:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _interrupt

_InitTimer1:

;C_Meter_AVR.c,102 :: 		void InitTimer1(){
;C_Meter_AVR.c,103 :: 		SREG_I_bit = 1;
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;C_Meter_AVR.c,104 :: 		TCCR1A = 0x80;
	LDI        R27, 128
	OUT        TCCR1A+0, R27
;C_Meter_AVR.c,105 :: 		TCCR1B = 0x0C;
	LDI        R27, 12
	OUT        TCCR1B+0, R27
;C_Meter_AVR.c,106 :: 		OCR1AH = 0x7A;
	LDI        R27, 122
	OUT        OCR1AH+0, R27
;C_Meter_AVR.c,107 :: 		OCR1AL = 0x11;
	LDI        R27, 17
	OUT        OCR1AL+0, R27
;C_Meter_AVR.c,108 :: 		OCIE1A_bit = 1;
	IN         R27, OCIE1A_bit+0
	SBR        R27, BitMask(OCIE1A_bit+0)
	OUT        OCIE1A_bit+0, R27
;C_Meter_AVR.c,109 :: 		}
L_end_InitTimer1:
	RET
; end of _InitTimer1

_Timer1Overflow_ISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;C_Meter_AVR.c,111 :: 		void Timer1Overflow_ISR() org IVT_ADDR_TIMER1_COMPA {
;C_Meter_AVR.c,113 :: 		timer_count_end = int_count;
	LDS        R16, _int_count+0
	LDS        R17, _int_count+1
	LDS        R18, _int_count+2
	LDS        R19, _int_count+3
	STS        _timer_count_end+0, R16
	STS        _timer_count_end+1, R17
	STS        _timer_count_end+2, R18
	STS        _timer_count_end+3, R19
;C_Meter_AVR.c,114 :: 		int_count = 0;
	LDI        R27, 0
	STS        _int_count+0, R27
	STS        _int_count+1, R27
	STS        _int_count+2, R27
	STS        _int_count+3, R27
;C_Meter_AVR.c,115 :: 		sec_flag = true;
	LDI        R27, 1
	STS        _sec_flag+0, R27
;C_Meter_AVR.c,116 :: 		}
L_end_Timer1Overflow_ISR:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _Timer1Overflow_ISR
